cookutils view cook @ rev 446

cook: use pkgconfig file in sysroot
author Christophe Lincoln <pankso@slitaz.org>
date Tue May 29 14:23:13 2012 +0000 (2012-05-29)
parents 38f5bf899513
children 8e43a0f15aa0
line source
1 #!/bin/sh
2 #
3 # Cook - A tool to cook and generate SliTaz packages. Read the README
4 # before adding or modifing any code in cook!
5 #
6 # Copyright (C) SliTaz GNU/Linux - GNU gpl v3
7 # Author: Christophe Lincoln <pankso@slitaz.org>
8 #
9 . /usr/lib/slitaz/libcook.sh
11 #
12 # Functions
13 #
15 usage() {
16 cat << EOT
18 $(echo -e "\033[1m$(gettext "Usage:")\033[0m") cook [package|command] [list|--option]
20 $(echo -e "\033[1m$(gettext "Commands:")\033[0m")
21 usage|help $(gettext "Display this short usage.")
22 setup $(gettext "Setup your build environment.")
23 *-setup $(gettext "Setup a cross environment.")
24 test $(gettext "Test environment and cook a package.")
25 list-wok $(gettext "List packages in the wok.")
26 search $(gettext "Simple packages search function.")
27 new $(gettext "Create a new package with a receipt".)
28 list $(gettext "Cook a list of packages.")
29 clean-wok $(gettext "Clean-up all packages files.")
30 clean-src $(gettext "Clean-up all packages sources.")
31 pkgdb $(gettext "Create packages DB lists and flavors.")
33 $(echo -e "\033[1m$(gettext "Options:")\033[0m")
34 --clean|-c Cook : $(gettext "clean the package in the wok.")
35 --install|-i Cook : $(gettext "cook and install the package.")
36 --getsrc|-gs Cook : $(gettext "get the package source tarball.")
37 --block|-b Cook : $(gettext "Block a package so cook will skip it.")
38 --unblock|-ub Cook : $(gettext "Unblock a blocked package.")
39 --interactive|-x New : $(gettext "create a receipt interactively.")
40 --wok Setup: $(gettext "clone the cooking wok from Hg repo.")
41 --stable Setup: $(gettext "clone the stable wok from Hg repo.")
42 --undigest Setup: $(gettext "clone the undigest wok from Hg repo.")
43 --tiny Setup: $(gettext "clone the tiny SliTaz wok from Hg repo.")
44 --forced Setup: $(gettext "force reinstall of chroot packages.")
45 --flavors Pkgdb: $(gettext "create up-to-date flavors files.")
47 EOT
48 exit 0
49 }
51 # Log activities, we want first letter capitalized.
52 log() {
53 grep ^[A-Z] | \
54 sed s"#^[A-Z]\([^']*\)#$(date '+%Y-%m-%d %H:%M') : \0#" >> $activity
55 }
57 # We don't want these escapes in web interface.
58 clean_log() {
59 sed -i -e s'|\[70G\[ \[1;32m| |' \
60 -e s'|\[0;39m \]||' $LOGS/$pkg.log
61 }
63 # Be sure package exists in wok.
64 check_pkg_in_wok() {
65 if [ ! -d "$WOK/$pkg" ]; then
66 gettext -e "\nUnable to find package in the wok:"
67 echo -e " $pkg\n" && exit 1
68 fi
69 }
71 if_empty_value() {
72 if [ -z "$value" ]; then
73 gettext "QA: empty variable:"; echo -e " ${var}=\"\"\n"
74 exit 1
75 fi
76 }
78 # Initialize files used in $CACHE
79 init_db_files() {
80 gettext "Creating directories structure in:"; echo " $SLITAZ"
81 mkdir -p $WOK $PKGS $SRC $CACHE $LOGS
82 gettext "Creating DB files in:"; echo " $CACHE"
83 for f in $activity $command $broken $blocked
84 do
85 touch $f
86 done
87 }
89 # QA: check a receipt consistency before building.
90 receipt_quality() {
91 gettext -e "QA: checking package receipt...\n"
92 unset online
93 if ifconfig | grep -q -A 1 "^[a-z]*[0-9]" | fgrep 'addr:'; then
94 online="online"
95 fi
96 for var in PACKAGE VERSION CATEGORY SHORT_DESC MAINTAINER WEB_SITE
97 do
98 unset value
99 value="$(. $receipt ; eval echo \$$var)"
100 case "$var" in
101 PACKAGE|VERSION|SHORT_DESC)
102 if_empty_value ;;
103 CATEGORY)
104 [ -z "$value" ] && value="empty"
105 valid="base-system x-window utilities network graphics \
106 multimedia office development system-tools security games \
107 misc meta non-free"
108 if ! echo "$valid" | grep -q -w "$value"; then
109 gettext "QA: unknown category:"; echo -e " $value\n"
110 exit 1
111 fi ;;
112 WEB_SITE)
113 # We don't check WGET_URL since if dl is needed it will fail.
114 # Break also if we're not online. Here error is not fatal.
115 if_empty_value
116 [ -z "$online" ] || break
117 if ! busybox wget -T 12 -s $value 2>/dev/null; then
118 gettext "QA: Unable to reach:"; echo -e " $value"
119 fi ;;
120 esac
121 done
122 }
124 # Paths used in receipt and by cook itself.
125 set_paths() {
126 pkgdir=$WOK/$PACKAGE
127 src=$pkgdir/source/$PACKAGE-$VERSION
128 taz=$pkgdir/taz
129 pack=$taz/$PACKAGE-${VERSION}${EXTRAVERSION}
130 fs=$pack/fs
131 stuff=$pkgdir/stuff
132 install=$pkgdir/install
133 if [ "$WANTED" ]; then
134 wanted=${WANTED%% *}
135 src=$WOK/$wanted/source/$wanted-$VERSION
136 install=$WOK/$wanted/install
137 wanted_stuff=$WOK/$wanted/stuff
138 fi
139 # Kernel version is set from linux-api-headers since it is part of toolchain.
140 if [ -f "$INSTALLED/linux-api-headers/receipt" ]; then
141 kvers=$(grep ^VERSION= $INSTALLED/linux-api-headers/receipt | cut -d '"' -f 2)
142 fi
143 # Old way compatibility.
144 _pkg=$install
145 }
147 # Create source tarball when URL is a SCM.
148 create_tarball() {
149 gettext "Creating tarball: "; echo "$tarball"
150 if [ "$LZMA_SRC" ]; then
151 tar -c $pkgsrc | lzma e $SRC/$tarball -si || exit 1
152 else
153 tar cjf $tarball $pkgsrc || exit 1
154 mv $tarball $SRC && rm -rf $pkgsrc
155 fi
156 }
158 # Get package source. For SCM we are in cache so clone here and create a
159 # tarball here.
160 get_source() {
161 pwd=$(pwd)
162 pkgsrc=${SOURCE:-$PACKAGE}-$VERSION
163 tarball=$pkgsrc.tar.bz2
164 [ "$LZMA_SRC" ] && tarball=$pkgsrc.tar.lzma
165 case "$WGET_URL" in
166 http://*|ftp://*)
167 # Busybox Wget is better!
168 busybox wget -T 60 -c -O $SRC/$TARBALL $WGET_URL || \
169 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
170 https://*)
171 wget -c --no-check-certificate -O $SRC/$TARBALL $WGET_URL || \
172 (echo -e "ERROR: wget $WGET_URL" && exit 1) ;;
173 hg*|mercurial*)
174 if $(echo "$WGET_URL" | fgrep -q "hg|"); then
175 url=${WGET_URL#hg|}
176 else
177 url=${WGET_URL#mercurial|}
178 fi
179 gettext -e "Getting source from Hg...\n"
180 echo "URL: $url"
181 gettext "Cloning to: "; echo "$pwd/$pkgsrc"
182 if [ "$BRANCH" ]; then
183 echo "Hg branch: $BRANCH"
184 hg clone $url --rev $BRANCH $pkgsrc || \
185 (echo "ERROR: hg clone $url --rev $BRANCH" && exit 1)
186 else
187 hg clone $url $pkgsrc || (echo "ERROR: hg clone $url" && exit 1)
188 fi
189 rm -rf $pkgsrc/.hg
190 create_tarball ;;
191 git*)
192 url=${WGET_URL#git|}
193 gettext -e "Getting source from Git...\n"
194 echo "URL: $url"
195 git clone $url $pkgsrc || (echo "ERROR: git clone $url" && exit 1)
196 if [ "$BRANCH" ]; then
197 echo "Git branch: $BRANCH"
198 cd $pkgsrc && git checkout $BRANCH && cd ..
199 fi
200 create_tarball ;;
201 cvs*)
202 url=${WGET_URL#cvs|}
203 mod=$PACKAGE
204 [ "$CVS_MODULE" ] && mod=$CVS_MODULE
205 gettext -e "Getting source from CVS...\n"
206 echo "URL: $url"
207 [ "$CVS_MODULE" ] && echo "CVS module: $mod"
208 gettext "Cloning to: "; echo "$pwd/$mod"
209 cvs -d:$url co $mod && mv $mod $pkgsrc
210 create_tarball ;;
211 svn*|subversion*)
212 if $(echo "$WGET_URL" | fgrep -q "svn|"); then
213 url=${WGET_URL#svn|}
214 else
215 url=${WGET_URL#subversion|}
216 fi
217 gettext -e "Getting source from SVN...\n"
218 echo "URL: $url"
219 if [ "$BRANCH" ]; then
220 echo t | svn co $url -r $BRANCH $pkgsrc
221 else
222 echo t | svn co $url $pkgsrc
223 fi
224 create_tarball ;;
225 *)
226 gettext -e "\nERROR: Unable to handle:"; echo -e " $WGET_URL \n" | \
227 tee -a $LOGS/$PACKAGE.log
228 exit 1 ;;
229 esac
230 }
232 # Extract source package.
233 extract_source() {
234 if [ ! -s "$SRC/$TARBALL" ]; then
235 local url
236 url="http://mirror.slitaz.org/sources/packages"
237 url=$url/${TARBALL:0:1}/$TARBALL
238 gettext "Getting source from mirror:"; echo " $url"
239 busybox wget -c -P $SRC $url || echo -e "ERROR: wget $url"
240 fi
241 gettext "Extracting:"; echo " $TARBALL"
242 case "$TARBALL" in
243 *.tar.gz|*.tgz) tar xzf $SRC/$TARBALL 2>/dev/null ;;
244 *.tar.bz2|*.tbz|*.tbz2) tar xjf $SRC/$TARBALL 2>/dev/null ;;
245 *.tar.lzma) tar xaf $SRC/$TARBALL ;;
246 *.tar) tar xf $SRC/$TARBALL ;;
247 *.zip|*.xpi) unzip -o $SRC/$TARBALL ;;
248 *.xz) unxz -c $SRC/$TARBALL | tar xf - ;;
249 *.Z) uncompress -c $SRC/$TARBALL | tar xf - ;;
250 *.rpm) rpm2cpio $SRC/$TARBALL | cpio -idm --quiet ;;
251 *.run) /bin/sh $SRC/$TARBALL $RUN_OPTS ;;
252 *) cp $SRC/$TARBALL $(pwd) ;;
253 esac
254 }
256 # Display cooked package summary.
257 summary() {
258 cd $WOK/$pkg
259 [ -d install ] && prod=$(du -sh install | awk '{print $1}' 2>/dev/null)
260 fs=$(du -sh taz/* | awk '{print $1}')
261 size=$(du -sh $PKGS/$pkg-${VERSION}*.tazpkg | awk '{print $1}')
262 files=$(cat taz/$pkg-*/files.list | wc -l)
263 cookdate=$(date "+%Y-%m-%d %H:%M")
264 sec=$time
265 div=$(( ($time + 30) / 60))
266 [ "$div" != 0 ] && min="~ ${div}m"
267 gettext "Summary for:"; echo " $PACKAGE $VERSION"
268 separator
269 [ "$prod" ] && echo "Produced : $prod"
270 cat << EOT
271 Packed : $fs
272 Compressed : $size
273 Files : $files
274 Cook time : ${sec}s $min
275 Cook date : $cookdate
276 Host arch : $ARCH
277 $(separator)
278 EOT
279 }
281 # Display debugging error info.
282 debug_info() {
283 echo -e "\nDebug information"
284 separator
285 echo "Cook date: $(date '+%Y-%m-%d %H:%M')"
286 for error in \
287 ERROR "No package" "cp: can't" "can't open" "can't cd" \
288 "error:" "fatal error:"
289 do
290 fgrep "$error" $LOGS/$pkg.log
291 done
292 separator && newline
293 }
295 # Copy all generic files (locale, pixmaps, .desktop). We use standard paths,
296 # so some packages need to copy these files with the receipt and genpkg_rules.
297 copy_generic_files() {
298 # $LOCALE is set in cook.conf
299 if [ "$LOCALE" ]; then
300 if [ -d "$install/usr/share/locale" ]; then
301 mkdir -p $fs/usr/share/locale
302 for i in $LOCALE
303 do
304 if [ -d "$install/usr/share/locale/$i" ]; then
305 cp -a $install/usr/share/locale/$i $fs/usr/share/locale
306 fi
307 done
308 fi
309 fi
311 # Generic pixmaps copy can be disabled with GENERIC_PIXMAPS="no"
312 if [ "$GENERIC_PIXMAPS" != "no" ]; then
313 if [ -d "$install/usr/share/pixmaps" ]; then
314 mkdir -p $fs/usr/share/pixmaps
315 cp -a $install/usr/share/pixmaps/$PACKAGE.png \
316 $fs/usr/share/pixmaps 2>/dev/null || continue
317 cp -a $install/usr/share/pixmaps/$PACKAGE.xpm \
318 $fs/usr/share/pixmaps 2>/dev/null || continue
319 fi
321 # Custom or homemade PNG pixmap can be in stuff.
322 if [ -f "$stuff/$PACKAGE.png" ]; then
323 mkdir -p $fs/usr/share/pixmaps
324 cp -a $stuff/$PACKAGE.png $fs/usr/share/pixmaps
325 fi
326 fi
328 # Desktop entry (.desktop).
329 # Generic desktop entry copy can be disabled with GENERIC_MENUS="no"
330 if [ "$GENERIC_MENUS" != "no" ]; then
331 if [ -d "$install/usr/share/applications" ] && [ "$WANTED" == "" ]; then
332 cp -a $install/usr/share/applications $fs/usr/share
333 fi
334 fi
336 # Homemade desktop file(s) can be in stuff.
337 if [ -d "$stuff/applications" ]; then
338 mkdir -p $fs/usr/share
339 cp -a $stuff/applications $fs/usr/share
340 fi
341 if [ -f "$stuff/$PACKAGE.desktop" ]; then
342 mkdir -p $fs/usr/share/applications
343 cp -a $stuff/$PACKAGE.desktop $fs/usr/share/applications
344 fi
345 }
347 # Find and strip : --strip-all (-s) or --strip-debug on static libs as well
348 # as removing uneeded files like in Python packages. Cross compiled binaries
349 # must be stripped with cross-tools aka $ARCH-slitaz-*-strip
350 strip_package() {
351 case "$ARCH" in
352 arm|x86_64) export STRIP=${HOST_SYSTEM}-strip ;;
353 *) export STRIP=strip ;;
354 esac
355 gettext "Executing strip on all files..."
356 for dir in $fs/bin $fs/sbin $fs/usr/bin $fs/usr/sbin $fs/usr/games
357 do
358 if [ -d "$dir" ]; then
359 find $dir -type f -exec $STRIP -s '{}' 2>/dev/null \;
360 fi
361 done
362 find $fs -name "*.so*" -exec $STRIP -s '{}' 2>/dev/null \;
363 find $fs -name "*.a" -exec $STRIP --strip-debug '{}' 2>/dev/null \;
364 status
366 # Remove Python .pyc and .pyo from packages.
367 if echo "$PACKAGE $DEPENDS" | fgrep -q "python"; then
368 gettext "Removing Python compiled files..."
369 find $fs -type f -name "*.pyc" -delete 2>/dev/null
370 find $fs -type f -name "*.pyo" -delete 2>/dev/null
371 status
372 fi
374 # Remove Perl perllocal.pod and .packlist from packages.
375 if echo "$DEPENDS" | fgrep -q "perl"; then
376 gettext "Removing Perl compiled files..."
377 find $fs -type f -name "perllocal.pod" -delete 2>/dev/null
378 find $fs -type f -name ".packlist" -delete 2>/dev/null
379 status
380 fi
381 }
383 # Remove installed deps.
384 remove_deps() {
385 # Now remove installed build deps.
386 diff="$CACHE/installed.cook.diff"
387 if [ -s "$CACHE/installed.cook.diff" ]; then
388 deps=$(cat $diff | grep ^+[a-zA-Z0-9] | sed s/^+//)
389 nb=$(cat $diff | grep ^+[a-zA-Z0-9] | wc -l)
390 gettext "Build dependencies to remove:"; echo " $nb $root"
391 gettext "Removing:"
392 for dep in $deps
393 do
394 echo -n " $dep"
395 echo 'y' | tazpkg remove $dep --root=$root >/dev/null
396 done
397 echo -e "\n"
398 # Keep the last diff for debug and info.
399 mv -f $CACHE/installed.cook.diff $CACHE/installed.diff
400 fi
401 }
403 # The main cook function.
404 cookit() {
405 echo "Cook: $PACKAGE $VERSION"
406 separator
407 set_paths
409 # Handle cross-tools.
410 case "$ARCH" in
411 arm|x86_64)
412 # CROSS_COMPILE is used by at least Busybox and the kernel to set
413 # the cross-tools prefix. Sysroot the the root of our target arch
414 sysroot=$CROSS_TREE/sysroot
415 tools=$CROSS_TREE/tools
416 # Set root path when cross compiling. ARM tested but not x86_64
417 # When cross compiling we must install build deps in $sysroot.
418 arch="-${ARCH}"
419 root=$sysroot
420 echo "$ARCH sysroot: $sysroot"
421 echo "Adding $tools/bin to PATH"
422 export PATH=$PATH:$tools/bin
423 export PKG_CONFIG_PATH=$sysroot/usr/lib/pkgconfig
424 export CROSS_COMPILE=${HOST_SYSTEM}-
425 echo "Using cross-tools: $CROSS_COMPILE"
426 if [ "$ARCH" == "x86_64" ]; then
427 export CC="${HOST_SYSTEM}-gcc -m64"
428 export CXX="${HOST_SYSTEM}-g++ -m64"
429 else
430 export CC=${HOST_SYSTEM}-gcc
431 export CXX=${HOST_SYSTEM}-g++
432 fi
433 export AR=${HOST_SYSTEM}-ar
434 export AS=${HOST_SYSTEM}-as
435 export RANLIB=${HOST_SYSTEM}-ranlib
436 export LD=${HOST_SYSTEM}-ld
437 export STRIP=${HOST_SYSTEM}-strip ;;
438 esac
440 [ "$QA" ] && receipt_quality
441 cd $pkgdir
442 rm -rf install taz source
444 # Disable -pipe if less than 512Mb free RAM.
445 free=$(free | fgrep '/+ buffers' | tr -s ' ' | cut -f 4 -d ' ')
446 if [ "$free" -lt 524288 ] && [ "$CFLAGS" != "${CFLAGS/-pipe}" ]; then
447 gettext -e "Disabling -pipe compile flag: $free RAM\n"
448 CFLAGS="${CFLAGS/-pipe}" && CFLAGS=$(echo "$CFLAGS" | tr -s ' ')
449 CXXFLAGS="${CXXFLAGS/-pipe}" && \
450 CXXFLAGS=$(echo "$CXXFLAGS" | tr -s ' ')
451 fi
452 unset free
454 # Export flags and path to be used by make and receipt.
455 DESTDIR=$pkgdir/install
456 export DESTDIR MAKEFLAGS CFLAGS CXXFLAGS CONFIG_SITE LC_ALL=C LANG=C
457 #LDFLAGS
459 # Check for build deps and handle implicit depends of *-dev packages
460 # (ex: libusb-dev :: libusb).
461 rm -f $CACHE/installed.local $CACHE/installed.web $CACHE/missing.dep
462 touch $CACHE/installed.local $CACHE/installed.web
463 [ "$BUILD_DEPENDS" ] && gettext -e "Checking build dependencies...\n"
464 [ "$root" ] && echo "Using packages DB: ${root}$DB"
465 for dep in $BUILD_DEPENDS
466 do
467 implicit=${dep%-dev}
468 for i in $dep $implicit
469 do
470 if [ ! -f "${root}$INSTALLED/$i/receipt" ]; then
471 # Try local package first. In some cases implicit doesn't exist, ex:
472 # libboost-dev exists but not libboost, so check if we got vers.
473 unset vers
474 vers=$(. $WOK/$i/receipt 2>/dev/null ; echo $VERSION)
475 # We may have a local package.
476 if [ ! "$vers" ]; then
477 vers=$(grep "^$i |" $PKGS/packages.desc | awk '{print $3}')
478 fi
479 debug "bdep: $i version: $vers"
480 if [ -f "$PKGS/$i-${vers}${arch}.tazpkg" ]; then
481 echo $i-${vers}${arch}.tazpkg >> $CACHE/installed.local
482 else
483 # Priority to package version in wok (maybe more up-to-date)
484 # than the mirrored one.
485 if [ "$vers" ]; then
486 if fgrep -q $i-${vers}${arch} ${root}$DB/packages.list; then
487 echo $i >> $CACHE/installed.web
488 else
489 # So package exists in wok but not available.
490 gettext "Missing dep (wok/pkg):"; echo " $i $vers"
491 echo $i >> $CACHE/missing.dep
492 fi
493 else
494 # Package is not in wok but may be in online repo.
495 if fgrep -q $i-${vers}${arch} ${root}$DB/packages.list; then
496 echo $i >> $CACHE/installed.web
497 else
498 echo "ERROR: unknown dep $i" && exit 1
499 fi
500 fi
501 fi
502 fi
503 done
504 done
506 # Get the list of installed packages
507 cd ${root}$INSTALLED && ls -1 > $CACHE/installed.list
509 # Have we a missing build dep to cook ?
510 if [ -s "$CACHE/missing.dep" ] && [ "$AUTO_COOK" ]; then
511 gettext -e "Auto cook config is set : AUTO_COOK\n"
512 cp -f $LOGS/$PACKAGE.log $LOGS/$PACKAGE.log.$$
513 for i in $(uniq $CACHE/missing.dep)
514 do
515 (gettext "Building dep (wok/pkg) :"; echo " $i $vers") | \
516 tee -a $LOGS/$PACKAGE.log.$$
517 cook $i || (echo -e "ERROR: can't cook dep '$i'\n" && \
518 fgrep "remove: " $LOGS/$i.log && \
519 fgrep "Removing: " $LOGS/$i.log && newline) | \
520 tee -a $LOGS/$PACKAGE.log.$$ && break
521 done
522 rm -f $CACHE/missing.dep
523 mv $LOGS/$PACKAGE.log.$$ $LOGS/$PACKAGE.log
524 fi
526 # QA: Exit on missing dep errors. We exit in both cases, if AUTO_COOK
527 # is enabled and cook fails we have ERROR in log, if no auto cook we have
528 # missing dep in cached file.
529 if fgrep -q "ERROR:" $LOGS/$pkg.log || [ -s "$CACHE/missing.dep" ]; then
530 [ -s "$CACHE/missing.dep" ] && nb=$(cat $CACHE/missing.dep | wc -l)
531 echo "ERROR: missing dep $nb" && exit 1
532 fi
534 # Install local packages: package-version${arch}
535 cd $PKGS
536 for i in $(uniq $CACHE/installed.local)
537 do
538 gettext "Installing dep (pkg/local):"; echo " $i"
539 tazpkg install $i --root=$root >/dev/null
540 done
542 # Install web or cached packages (if mirror is set to $PKGS we only
543 # use local packages).
544 for i in $(uniq $CACHE/installed.web)
545 do
546 gettext "Installing dep (web/cache):"; echo " $i"
547 tazpkg get-install $i --root=$root >/dev/null
548 done
550 # If a cook failed deps are removed.
551 cd ${root}$INSTALLED && ls -1 > $CACHE/installed.cook && cd $CACHE
552 [ ! -s "installed.cook.diff" ] && \
553 busybox diff installed.list installed.cook > installed.cook.diff
554 deps=$(cat installed.cook.diff | grep ^+[a-zA-Z0-9] | wc -l)
556 # Get source tarball and make sure we have source dir named:
557 # $PACKAGE-$VERSION to be standard in receipts. Here we use tar.lzma
558 # tarball if it exists.
559 if [ "$WGET_URL" ] && [ ! -f "$SRC/$TARBALL" ]; then
560 if [ -f "$SRC/${SOURCE:-$PACKAGE}-$VERSION.tar.lzma" ]; then
561 TARBALL=${SOURCE:-$PACKAGE}-$VERSION.tar.lzma
562 LZMA_SRC=""
563 else
564 get_source || exit 1
565 fi
566 fi
567 if [ ! "$WANTED" ] && [ "$TARBALL" ] && [ ! -d "$src" ]; then
568 mkdir -p $pkgdir/source/tmp && cd $pkgdir/source/tmp
569 if ! extract_source ; then
570 get_source
571 extract_source || exit 1
572 fi
573 if [ "$LZMA_SRC" ]; then
574 cd $pkgdir/source
575 if [ "$(ls -A tmp | wc -l)" -gl 1 ] || [ -f "$(echo tmp/*)" ]; then
576 mv tmp tmp-1 && mkdir tmp
577 mv tmp-1 tmp/${SOURCE:-$PACKAGE}-$VERSION
578 fi
579 if [ -d "tmp/${SOURCE:-$PACKAGE}-$VERSION" ]; then
580 cd tmp && tar -c * | lzma e $SRC/$TARBALL -si
581 fi
582 fi
583 cd $pkgdir/source/tmp
584 # Some archives are not well done and don't extract to one dir (ex lzma).
585 files=$(ls | wc -l)
586 [ "$files" == 1 ] && [ -d "$(ls)" ] && mv * ../$PACKAGE-$VERSION
587 [ "$files" == 1 ] && [ -f "$(ls)" ] && mkdir -p ../$PACKAGE-$VERSION && \
588 mv * ../$PACKAGE-$VERSION/$TARBALL
589 [ "$files" -gt 1 ] && mkdir -p ../$PACKAGE-$VERSION && \
590 mv * ../$PACKAGE-$VERSION
591 cd .. && rm -rf tmp
592 fi
594 # Execute receipt rules.
595 if grep -q ^compile_rules $receipt; then
596 echo "Executing: compile_rules"
597 echo "CFLAGS : $CFLAGS"
598 #echo "LDFLAGS : $LDFLAGS"
599 [ -d "$src" ] && cd $src
600 compile_rules $@ || exit 1
601 # Stay compatible with _pkg
602 [ -d "$src/_pkg" ] && mv $src/_pkg $install
603 # QA: compile_rules success so valid.
604 mkdir -p $install
605 else
606 # QA: No compile_rules so no error, valid.
607 mkdir -p $install
608 fi
609 separator && newline
611 # Execute testsuite.
612 if grep -q ^testsuite $receipt; then
613 echo "Running testsuite"
614 separator
615 testsuite $@ || exit 1
616 separator && newline
617 fi
618 }
620 # Cook quality assurance.
621 cookit_quality() {
622 if [ ! -d "$WOK/$pkg/install" ] && [ ! "$WANTED" ]; then
623 echo -e "ERROR: cook failed" | tee -a $LOGS/$pkg.log
624 fi
625 # ERROR can be echoed any time in cookit()
626 if fgrep -q ERROR: $LOGS/$pkg.log; then
627 debug_info | tee -a $LOGS/$pkg.log
628 rm -f $command && exit 1
629 fi
630 }
632 # Create the package. Wanted to use Tazpkg to create a tazpkg package at first,
633 # but it doesn't handle EXTRAVERSION.
634 packit() {
635 set_paths
637 # Handle cross compilation
638 case "$ARCH" in
639 arm|x86_64) arch="-$ARCH" ;;
640 esac
642 echo "Pack: $PACKAGE ${VERSION}${arch}"
643 separator
645 if grep -q ^genpkg_rules $receipt; then
646 gettext -e "Executing: genpkg_rules\n"
647 set -e && cd $pkgdir && mkdir -p $fs
648 genpkg_rules || echo -e "\nERROR: genpkg_rules failed\n" >> \
649 $LOGS/$pkg.log
650 else
651 gettext "No packages rules: meta package"; echo
652 mkdir -p $fs
653 fi
655 # First QA check to stop now if genpkg_rules failed.
656 if fgrep -q ERROR: $LOGS/$pkg.log; then
657 exit 1
658 fi
660 cd $taz
661 for file in receipt description.txt
662 do
663 [ ! -f "../$file" ] && continue
664 gettext "Copying"; echo -n " $file..."
665 cp -f ../$file $pack && chown 0.0 $pack/$file && status
666 done
667 copy_generic_files
669 # Create files.list with redirecting find output.
670 gettext "Creating the list of files..." && cd $fs
671 find . -type f -print > ../files.list
672 find . -type l -print >> ../files.list
673 cd .. && sed -i s/'^.'/''/ files.list
674 status
676 # Strip and stuff files.
677 strip_package
679 # Md5sum of files.
680 gettext "Creating md5sum of files..."
681 while read file; do
682 [ -L "fs$file" ] && continue
683 [ -f "fs$file" ] || continue
684 case "$file" in
685 /lib/modules/*/modules.*|*.pyc) continue ;;
686 esac
687 md5sum "fs$file" | sed 's/ fs/ /'
688 done < files.list > md5sum
689 status
690 UNPACKED_SIZE=$(du -chs fs receipt files.list md5sum \
691 description.txt 2> /dev/null | awk \
692 '{ sz=$1 } END { print sz }')
694 # Build cpio archives.
695 gettext "Compressing the fs... "
696 find fs | cpio -o -H newc --quiet | lzma e fs.cpio.lzma -si
697 rm -rf fs
698 status
699 PACKED_SIZE=$(du -chs fs.cpio.lzma receipt files.list \
700 md5sum description.txt 2> /dev/null | awk \
701 '{ sz=$1 } END { print sz }')
702 gettext "Updating receipt sizes..."
703 sed -i s/^PACKED_SIZE.*$// receipt
704 sed -i s/^UNPACKED_SIZE.*$// receipt
705 sed -i "s/^PACKAGE=/PACKED_SIZE=\"$PACKED_SIZE\"\nUNPACKED_SIZE=\"$UNPACKED_SIZE\"\nPACKAGE=/" receipt
706 status
708 # Set extra version.
709 if [ "$EXTRAVERSION" ]; then
710 gettext "Updating receipt EXTRAVERSION: "; echo -n "$EXTRAVERSION"
711 sed -i s/^EXTRAVERSION.*$// receipt
712 sed -i "s/^VERSION=/EXTRAVERSION=\"$EXTRAVERSION\"\nVERSION=/" receipt
713 status
714 fi
716 # Compress.
717 gettext "Creating full cpio archive... "
718 find . -print | cpio -o -H newc --quiet > \
719 ../$PACKAGE-${VERSION}${EXTRAVERSION}${arch}.tazpkg
720 status
721 gettext "Restoring original package tree... "
722 unlzma -c fs.cpio.lzma | cpio -idm --quiet
723 status
724 rm fs.cpio.lzma && cd ..
726 # QA and give info.
727 tazpkg=$(ls *.tazpkg)
728 packit_quality
729 separator && gettext "Package:"; echo -e " $tazpkg\n"
730 }
732 # Verify package quality and consistency.
733 packit_quality() {
734 #gettext "QA: Checking for broken link..."
735 #link=$(find $fs/usr -type l -follow)
736 #[ "$link" ] && echo -e "\nERROR: broken link in filesystem"
737 #status
739 # Exit if any error found in log file.
740 if fgrep -q ERROR: $LOGS/$pkg.log; then
741 rm -f $command && exit 1
742 fi
744 gettext "QA: Checking for empty package..."
745 files=$(cat $WOK/$pkg/taz/$pkg-*/files.list | wc -l)
746 if [ "$files" == 0 ] && [ "$CATEGORY" != "meta" ]; then
747 echo -e "\nERROR: empty package"
748 rm -f $command && exit 1
749 else
750 # Ls sort by name so the first file is the one we want.
751 old=$(ls $PKGS/$pkg-*.tazpkg 2>/dev/null | head -n 1)
752 status
753 if [ -f "$old" ]; then
754 gettext "Removing old: $(basename $old)"
755 rm -f $old && status
756 fi
757 mv -f $pkgdir/taz/$pkg-*.tazpkg $PKGS
758 sed -i /^${pkg}$/d $broken
759 #gettext "Removing source tree..."
760 #rm -f $WOK/$pkg/source && status
761 fi
762 }
764 # Tic tac, tic tac...
765 tac() {
766 sed '1!G;h;$!d' $1
767 }
769 # Install package on --install or update the chroot.
770 install_package() {
771 case "$ARCH" in
772 arm|x86_64)
773 arch="-${ARCH}"
774 root=$CROSS_TREE/sysroot ;;
775 esac
776 # Install package if requested but skip install if target host doesn't
777 # match build system or it will break the build chroot.
778 build=$(echo $BUILD_SYSTEM | cut -d "-" -f 1)
779 if [ "$inst" ] && [ "$build" == "$ARCH" ]; then
780 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
781 cd $PKGS && tazpkg install \
782 $PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg --forced
783 else
784 gettext -e "Unable to install package, build has failed.\n\n"
785 exit 1
786 fi
787 fi
789 # Install package if part of the chroot to keep env up-to-date.
790 if [ -d "${root}$INSTALLED/$pkg" ]; then
791 . /etc/slitaz/cook.conf
792 . $WOK/$pkg/taz/$pkg-*/receipt
793 echo "Updating $ARCH chroot environment..."
794 echo "Updating chroot: $pkg (${VERSION}${EXTRAVERSION}${arch})" | log
795 cd $PKGS && tazpkg install \
796 $pkg-${VERSION}${EXTRAVERSION}${arch}.tazpkg \
797 --forced --root=$root
798 fi
799 }
801 # Launch the cook command into a chroot jail protected by aufs.
802 # The current filesystems are used read-only and updates are
803 # stored in a separate branch.
804 try_aufs_chroot() {
806 base=/dev/shm/aufsmnt$$
808 # Can we setup the chroot ? Is it already done ?
809 grep -q ^AUFS_NOT_SUPPORTED $receipt && return
810 [ -n "$AUFS_MOUNTS" -a ! -f /aufs-umount.sh ] || return
811 lsmod | grep -q aufs || modprobe aufs 2> /dev/null || return
812 mkdir ${base}root ${base}rw || return
814 echo "Setup aufs chroot..."
816 # Sanity check
817 for i in / /proc /sys /dev/shm /home ; do
818 case " $AUFS_MOUNTS " in
819 *\ $i\ *) ;;
820 *) AUFS_MOUNTS="$AUFS_MOUNTS $i" ;;
821 esac
822 done
823 for mnt in $(echo $AUFS_MOUNTS | sort | uniq); do
824 mount --bind $mnt ${base}root$mnt
825 if [ $mnt == / ] && ! mount -t aufs -o br=${base}rw:/ none ${base}root; then
826 echo "Aufs mountage failure"
827 umount ${base}root
828 rmdir ${base}*
829 return
830 fi
831 echo "umount ${base}root$mnt" >> ${base}rw/aufs-umount.sh
832 done
834 chroot ${base}root $(cd $(dirname $0); pwd)/$(basename $0) "$@"
835 status=$?
837 echo "Leaving aufs chroot..."
838 tac ${base}rw/aufs-umount.sh | sh
839 rm -rf ${base}rw
840 umount ${base}root
841 rmdir $base*
842 # Dont install pkg twice... it's done after
843 #install_package
844 exit $status
845 }
847 # Create a XML feed for freshly built packages.
848 gen_rss() {
849 pubdate=$(date "+%a, %d %b %Y %X")
850 cat > $FEEDS/$pkg.xml << EOT
851 <item>
852 <title>$PACKAGE $VERSION${EXTRAVERSION}</title>
853 <link>${COOKER_URL}?pkg=$PACKAGE</link>
854 <guid>$PACKAGE-$VERSION${EXTRAVERSION}</guid>
855 <pubDate>$pubdate</pubDate>
856 <description>$SHORT_DESC</description>
857 </item>
858 EOT
859 }
861 #
862 # Commands
863 #
865 case "$1" in
866 usage|help|-u|-h)
867 usage ;;
868 list-wok)
869 gettext -e "\nList of packages in:"; echo " $WOK"
870 separator
871 cd $WOK && ls -1
872 separator
873 echo -n "Packages: " && ls | wc -l
874 newline ;;
875 activity)
876 cat $activity ;;
877 search)
878 # Just a simple search function, we dont need more actually.
879 query="$2"
880 newline
881 gettext "Search results for:"; echo " $query"
882 separator
883 cd $WOK && ls -1 | grep "$query"
884 separator && newline ;;
885 setup)
886 # Setup a build environment
887 check_root
888 echo "Cook: setup environment" | log
889 newline
890 gettext "Setting up your environment"; newline
891 separator && cd $SLITAZ
892 init_db_files
893 gettext "Checking for packages to install..."; echo
894 # Use setup pkgs from cross.conf or cook.conf. When cross compiling
895 # ARCH-setup or 'cross check-env' should be used before: cook setup
896 case "$ARCH" in
897 arm|x86_64)
898 if [ ! -x "/usr/bin/cross" ]; then
899 gettext "ERROR: cross is not installed"; echo
900 exit 1
901 fi
902 gettext "Using config file: /etc/slitaz/cross.conf"; echo
903 . /etc/slitaz/cross.conf ;;
904 esac
905 for pkg in $SETUP_PKGS; do
906 if [ "$forced" ]; then
907 tazpkg -gi $pkg --forced
908 else
909 [ -d "$INSTALLED/$pkg" ] || tazpkg get-install $pkg
910 fi
911 done
913 # Handle --options
914 case "$2" in
915 --wok)
916 hg clone $WOK_URL wok || exit 1 ;;
917 --stable)
918 hg clone $WOK_URL-stable wok || exit 1 ;;
919 --undigest)
920 hg clone $WOK_URL-undigest wok || exit 1 ;;
921 --tiny)
922 hg clone $WOK_URL-tiny wok || exit 1 ;;
923 esac
925 # SliTaz group and permissions
926 if ! grep -q ^slitaz /etc/group; then
927 gettext -e "Adding group: slitaz\n"
928 addgroup slitaz
929 fi
930 gettext -e "Setting permissions for slitaz group...\n"
931 find $SLITAZ -maxdepth 2 -exec chown root.slitaz {} \;
932 find $SLITAZ -maxdepth 2 -exec chmod g+w {} \;
933 separator
934 gettext -e "All done, ready to cook packages :-)\n\n" ;;
935 *-setup)
936 # Setup for cross compiling.
937 arch=${1%-setup}
938 check_root
939 echo "Cook: setup $arch cross environment" | log
940 newline
941 boldify $(gettext "Setting up your $arch cross environment")
942 separator
943 init_db_files
944 sed -i \
945 -e s"/ARCH=.*/ARCH=\"$arch\"/" \
946 -e s"/CROSS_TREE=.*/CROSS_TREE=\"\/cross\/$arch\"/" \
947 -e s'/BUILD_SYSTEM=.*/BUILD_SYSTEM=i486-slitaz-linux/' \
948 /etc/slitaz/cook.conf
949 case "$arch" in
950 arm)
951 sed -i \
952 -e s'/CFLAGS=.*/CFLAGS="-march=armv6 -O2"/' \
953 -e s'/HOST_SYSTEM=.*/HOST_SYSTEM=$ARCH-slitaz-linux-gnueabi/' \
954 -e s'/xorg-dev/""/' \
955 /etc/slitaz/cook.conf ;;
956 x86_64)
957 sed -i \
958 -e s'/CFLAGS=.*/CFLAGS=""/' \
959 -e s'/HOST_SYSTEM=.*/HOST_SYSTEM=$ARCH-slitaz-linux/' \
960 /etc/slitaz/cook.conf ;;
961 esac
962 . /etc/slitaz/cook.conf
963 sysroot=$CROSS_TREE/sysroot
964 tools=/cross/$arch/tools
965 root=$sysroot
966 CC=$tools/bin/${HOST_SYSTEM}-gcc
967 echo "Target arch : $ARCH"
968 echo "Configure args : $CONFIGURE_ARGS"
969 echo "Arch sysroot : $sysroot"
970 echo "Tools prefix : $tools/bin"
971 # Tell the packages manager wher to find packages.
972 echo "Packages DB : ${root}$DB"
973 mkdir -p ${root}$INSTALLED
974 cd ${root}$DB && rm -f *.bak
975 for list in packages.list packages.desc packages.equiv packages.md5
976 do
977 rm -f $list && ln -s $SLITAZ/packages/$list $list
978 done
979 # We must have the cross compiled glibc-base installed or default
980 # i486 package will be used as dep by tazpkg and then break the
981 # cross environment
982 if [ ! -f "${root}$INSTALLED/glibc-base/receipt" ]; then
983 colorize 36 "WARNING: (e)glibc-base is not installed in sysroot"
984 fi
985 # Show GCC version or warn if not yet compiled.
986 if [ -x $CC ]; then
987 echo "Cross compiler : ${HOST_SYSTEM}-gcc"
988 else
989 colorize 36 "C compiler is missing: ${HOST_SYSTEM}-gcc"
990 echo "Run 'cross compile' to cook a toolchain"
991 fi
992 separator && newline ;;
993 test)
994 # Test a cook environment.
995 echo "Cook test: testing the cook environment" | log
996 [ ! -d "$WOK" ] && exit 1
997 [ ! -d "$WOK/cooktest" ] && cp -r $DATA/cooktest $WOK
998 cook cooktest ;;
999 new)
1000 # Create the package folder and an empty receipt.
1001 pkg="$2"
1002 [ "$pkg" ] || usage
1003 newline
1004 if [ -d "$WOK/$pkg" ]; then
1005 echo -n "$pkg " && gettext "package already exists."
1006 echo -e "\n" && exit 1
1007 fi
1008 gettext "Creating"; echo -n " $WOK/$pkg"
1009 mkdir $WOK/$pkg && cd $WOK/$pkg && status
1010 gettext "Preparing the package receipt..."
1011 cp $DATA/receipt .
1012 sed -i s"/^PACKAGE=.*/PACKAGE=\"$pkg\"/" receipt
1013 status && newline
1015 # Interactive mode, asking and seding.
1016 case "$3" in
1017 --interactive|-x)
1018 gettext -e "Entering interactive mode...\n"
1019 separator
1020 echo "Package : $pkg"
1021 # Version.
1022 echo -n "Version : " ; read anser
1023 sed -i s/'VERSION=\"\"'/"VERSION=\"$anser\""/ receipt
1024 # Category.
1025 echo -n "Category : " ; read anser
1026 sed -i s/'CATEGORY=\"\"'/"CATEGORY=\"$anser\""/ receipt
1027 # Short description.
1028 echo -n "Short desc : " ; read anser
1029 sed -i s/'SHORT_DESC=\"\"'/"SHORT_DESC=\"$anser\""/ receipt
1030 # Maintainer.
1031 echo -n "Maintainer : " ; read anser
1032 sed -i s/'MAINTAINER=\"\"'/"MAINTAINER=\"$anser\""/ receipt
1033 # Web site.
1034 echo -n "Web site : " ; read anser
1035 sed -i s#'WEB_SITE=\"\"'#"WEB_SITE=\"$anser\""# receipt
1036 newline
1037 # Wget URL.
1038 echo "Wget URL to download source tarball."
1039 echo "Example : \$GNU_MIRROR/\$PACKAGE/\$TARBALL"
1040 echo -n "Wget url : " ; read anser
1041 sed -i s#'WGET_URL=\"$TARBALL\"'#"WGET_URL=\"$anser\""# receipt
1042 # Ask for a stuff dir.
1043 echo -n "Do you need a stuff directory ? (y/N) : " ; read anser
1044 if [ "$anser" = "y" ]; then
1045 echo -n "Creating the stuff directory..."
1046 mkdir $WOK/$pkg/stuff && status
1047 fi
1048 # Ask for a description file.
1049 echo -n "Are you going to write a description ? (y/N) : " ; read anser
1050 if [ "$anser" = "y" ]; then
1051 echo -n "Creating the description.txt file..."
1052 newline > $WOK/$pkg/description.txt && status
1053 fi
1054 separator
1055 gettext -e "Receipt is ready to use.\n"
1056 newline ;;
1057 esac ;;
1058 list)
1059 # Cook a list of packages (better use the Cooker since it will order
1060 # packages before executing cook).
1061 check_root
1062 [ -z "$2" ] && gettext -e "\nNo list in argument.\n\n" && exit 1
1063 [ ! -f "$2" ] && gettext -e "\nNo list found:" && \
1064 echo -e " $2\n" && exit 1
1065 echo "Cook list starting: $2" | log
1066 for pkg in $(cat $2)
1067 do
1068 cook $pkg || broken
1069 done ;;
1070 clean-wok)
1071 check_root
1072 gettext -e "\nCleaning all packages files..."
1073 rm -rf $WOK/*/taz $WOK/*/install $WOK/*/source
1074 status && newline ;;
1075 clean-src)
1076 check_root
1077 gettext -e "\nCleaning all packages sources..."
1078 rm -rf $WOK/*/source
1079 status && newline ;;
1080 pkgdb)
1081 # Create suitable packages list for TazPKG and only for built packages
1082 # as well as flavors files for TazLiTo. We dont need logs since we do it
1083 # manually to ensure everything is fine before syncing the mirror.
1084 case "$2" in
1085 --flavors)
1086 continue ;;
1087 *)
1088 [ "$2" ] && PKGS="$2"
1089 [ ! -d "$PKGS" ] && \
1090 gettext -e "\nPackages directory doesn't exist\n\n" && exit 1 ;;
1091 esac
1092 time=$(date +%s)
1093 flavors=$SLITAZ/flavors
1094 live=$SLITAZ/live
1095 echo "cook:pkgdb" > $command
1096 echo "Cook pkgdb: Creating all packages lists" | log
1097 newline
1098 gettext "Creating lists for: "; echo "$PKGS"
1099 separator
1100 gettext "Cook pkgdb started: "; date "+%Y-%m-%d %H:%M"
1101 cd $PKGS
1102 rm -f packages.*
1103 gettext -e "Creating: packages.list\n"
1104 ls -1 *.tazpkg | sed s'/.tazpkg//' > $PKGS/packages.list
1105 gettext -e "Creating: packages.md5\n"
1106 md5sum *.tazpkg > $PKGS/packages.md5
1107 md5sum packages.md5 | cut -f1 -d' ' > ID
1108 gettext -e "Creating lists from: "; echo "$WOK"
1109 cd $WOK
1110 for pkg in *
1111 do
1112 unset_receipt
1113 . $pkg/receipt
1114 if [ -f "$PKGS/$PACKAGE-${VERSION}${EXTRAVERSION}.tazpkg" ]; then
1115 # PACKED_SIZE and UNPACKED_SIZE are only in built receipt
1116 if [ -s $pkg/taz/*/receipt ]; then
1117 . $pkg/taz/*/receipt
1118 fi
1119 # packages.desc lets us search easily in DB
1120 cat >> $PKGS/packages.desc << EOT
1121 $PACKAGE | ${VERSION}$EXTRAVERSION | $SHORT_DESC | $CATEGORY | $WEB_SITE
1122 EOT
1123 # packages.txt used by tazpkg and tazpkg-web also to provide
1124 # a human readable package list with version and description.
1125 cat >> $PKGS/packages.txt << EOT
1126 $PACKAGE
1127 ${VERSION}$EXTRAVERSION
1128 $SHORT_DESC
1129 $PACKED_SIZE ($UNPACKED_SIZE installed)
1131 EOT
1132 # packages.equiv is used by tazpkg install to check depends.
1133 for i in $PROVIDE; do
1134 DEST=""
1135 echo $i | fgrep -q : && DEST="${i#*:}:"
1136 if grep -qs ^${i%:*}= $PKGS/packages.equiv; then
1137 sed -i "s/^${i%:*}=/${i%:*}=$DEST$PACKAGE /" \
1138 $PKGS/packages.equiv
1139 else
1140 echo "${i%:*}=$DEST$PACKAGE" >> $PKGS/packages.equiv
1141 fi
1142 done
1143 # files.list provides a list of all packages files.
1144 cat $pkg/taz/*/files.list | sed s/^/"$pkg: \0"/ >> \
1145 $PKGS/files.list
1146 fi
1147 done
1149 # Display list size.
1150 gettext -e "Done: packages.desc\n"
1151 gettext -e "Done: packages.txt\n"
1152 gettext -e "Done: packages.equiv\n"
1154 # files.list.lzma
1155 gettext -e "Creating: files.list.lzma\n"
1156 cd $PKGS && lzma e files.list files.list.lzma
1157 rm -f files.list
1159 # Display some info.
1160 separator
1161 nb=$(ls $PKGS/*.tazpkg | wc -l)
1162 time=$(($(date +%s) - $time))
1163 echo -e "Packages: $nb - Time: ${time}s\n"
1165 # Create all flavors files at once. Do we really need code to monitor
1166 # flavors changes ? Lets just build them with packages lists before
1167 # syncing the mirror.
1168 [ "$2" == "--flavors" ] || exit 1
1169 [ ! -d "$flavors" ] && echo -e "Missing flavors: $flavors\n" && exit 1
1170 [ -d "$live" ] || mkdir -p $live
1171 gettext "Creating flavors files in:"; echo " $live"
1172 echo "Cook pkgdb: Creating all flavors" | log
1173 separator
1174 gettext -e "Recharging lists to use latest packages...\n"
1175 tazpkg recharge >/dev/null 2>/dev/null
1177 # We need a custom tazlito config to set working dir to /home/slitaz.
1178 if [ ! -f "$live/tazlito.conf" ]; then
1179 echo "Creating configuration file: tazlito.conf"
1180 cp /etc/tazlito/tazlito.conf $live
1181 sed -i s@WORK_DIR=.*@WORK_DIR=\"/home/slitaz\"@ \
1182 $live/tazlito.conf
1183 fi
1185 # Update Hg flavors repo and pack.
1186 [ -d "$flavors/.hg" ] && cd $flavors && hg pull -u
1188 cd $live
1189 echo "Starting to generate flavors..."
1190 rm -f flavors.list *.flavor
1191 for i in $flavors/*
1192 do
1193 fl=$(basename $i)
1194 echo "Packing flavor: $(basename $i)"
1195 tazlito pack-flavor $fl >/dev/null || exit 1
1196 tazlito show-flavor $fl --brief --noheader 2> \
1197 /dev/null >> flavors.list
1198 done
1199 cp -f $live/*.flavor $live/flavors.list $PKGS
1200 separator && gettext "Flavors size: "; du -sh $live | awk '{print $1}'
1201 newline && rm -f $command ;;
1202 *)
1203 # Just cook and generate a package.
1204 check_root
1205 time=$(date +%s)
1206 pkg="$1"
1207 [ -z "$pkg" ] && usage
1208 receipt="$WOK/$pkg/receipt"
1209 check_pkg_in_wok && newline
1211 unset inst
1212 unset_receipt
1213 . $receipt
1215 # Handle cross compilation.
1217 # CROSS_NOTE: Actually we are running an ARM cooker but running
1218 # the cooker and build each commit in wok is not possible since
1219 # we dont cook the full wok for this arch. For ARM we need a set
1220 # of packages to handle a touch screen desktop, servers but not
1221 # erland.
1223 # The temporary solution is to build only reviewed and tested
1224 # packages with HOST_ARCH set in receipt.
1225 case "$ARCH" in
1226 arm)
1227 if [ ! "$HOST_ARCH" ]; then
1228 echo "cook: HOST_ARCH is not set in $pkg receipt"
1229 echo "cook: This package is not included in: $ARCH"
1230 [ "$CROSS_BUGS" ] && echo "bugs: $CROSS_BUGS"
1231 echo "Cook skip: $pkg is not included in: $ARCH" | log
1232 newline && exit 1
1233 fi ;;
1234 esac
1236 # Some packages are not included in some arch or fail to cross compile.
1237 : ${HOST_ARCH=i486}
1238 if ! $(echo "$HOST_ARCH" | fgrep -q $ARCH); then
1239 echo "cook: HOST_ARCH=$HOST_ARCH"
1240 echo "cook: $pkg doesn't cook or is not included in: $ARCH"
1241 [ "$CROSS_BUGS" ] && echo "bugs: $CROSS_BUGS"
1242 echo "Cook skip: $pkg doesn't cook or is not included in: $ARCH" | log
1243 newline && exit 1
1244 fi
1246 # Skip blocked, 3 lines also for the Cooker.
1247 if grep -q "^$pkg$" $blocked && [ "$2" != "--unblock" ]; then
1248 gettext -e "Blocked package:"; echo -e " $pkg\n" && exit 0
1249 fi
1251 try_aufs_chroot "$@"
1253 # Log and source receipt.
1254 echo "Cook started for: <a href='cooker.cgi?pkg=$pkg'>$pkg</a>" | log
1255 echo "cook:$pkg" > $command
1257 # Display and log info if cook process stopped.
1258 trap 'gettext -e "\n\nCook stopped: control-C\n\n" | \
1259 tee -a $LOGS/$pkg.log' INT
1261 # Handle --options
1262 case "$2" in
1263 --clean|-c)
1264 gettext -e "Cleaning:"; echo -n " $pkg"
1265 cd $WOK/$pkg && rm -rf install taz source
1266 status && newline && exit 0 ;;
1267 --install|-i)
1268 inst='yes' ;;
1269 --getsrc|-gs)
1270 gettext "Getting source for:"; echo " $pkg"
1271 separator && get_source
1272 echo -e "Tarball: $SRC/$TARBALL\n" && exit 0 ;;
1273 --block|-b)
1274 gettext "Blocking:"; echo -n " $pkg"
1275 [ $(grep "^$pkg$" $blocked) ] || echo "$pkg" >> $blocked
1276 status && newline && exit 0 ;;
1277 --unblock|-ub)
1278 gettext "Unblocking:"; echo -n " $pkg"
1279 sed -i "/^${pkg}$/"d $blocked
1280 status && newline && exit 0 ;;
1282 esac
1284 # Check if wanted is built now so we have separate log files.
1285 for wanted in $WANTED ; do
1286 if grep -q "^$wanted$" $blocked; then
1287 echo "WANTED package is blocked: $wanted" | tee $LOGS/$pkg.log
1288 newline && rm -f $command && exit 1
1289 fi
1290 if grep -q "^$wanted$" $broken; then
1291 echo "WANTED package is broken: $wanted" | tee $LOGS/$pkg.log
1292 newline && rm -f $command && exit 1
1293 fi
1294 if [ ! -d "$WOK/$wanted/install" ]; then
1295 cook "$wanted" || exit 1
1296 fi
1297 done
1299 # Cook and pack or exit on error and log everything.
1300 cookit $@ 2>&1 | tee $LOGS/$pkg.log
1301 remove_deps | tee -a $LOGS/$pkg.log
1302 cookit_quality
1303 packit 2>&1 | tee -a $LOGS/$pkg.log
1304 clean_log
1306 # Exit if any error in packing.
1307 if grep -q ^ERROR $LOGS/$pkg.log; then
1308 debug_info | tee -a $LOGS/$pkg.log
1309 rm -f $command && exit 1
1310 fi
1312 # Create an XML feed
1313 gen_rss
1315 # Time and summary
1316 time=$(($(date +%s) - $time))
1317 summary | tee -a $LOGS/$pkg.log
1318 newline
1320 # We may want to install/update.
1321 install_package
1323 # Finally we DONT WANT to build the *-dev or packages with WANTED="$pkg"
1324 # You want automation: use the Cooker Build Bot.
1325 rm -f $command ;;
1326 esac
1328 exit 0